Activity=com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

var KEY_ID=620;
var RESETTER_ID=621;
var PASSBLOCK_ID=236;
var CARDBLOCK_ID=237;
var BBLOCK_ID=238;
var BARRIER_ID=239;
var BARRIER2_ID=240;
var LBLOCK_ID=241;
var guiBlock=[0, 0, 0];

Block.defineBlock(PASSBLOCK_ID, "Keypad Block",[["kpblock", 1],["kpblock", 1],["kpblock", 0],["kpblock", 0],["kpblock", 0],["kpblock", 0]]);
Block.setShape(PASSBLOCK_ID, 0, 0, 0, 1, 1, 1);
Block.setDestroyTime(PASSBLOCK_ID, 12);
Block.setExplosionResistance(PASSBLOCK_ID, 32);

Block.defineBlock(CARDBLOCK_ID, "Card Block",[["kpblock",1],["kpblock",1],["cardblock",0],["cardblock",0],["cardblock",0],["cardblock",0]], 42);
Block.setShape(CARDBLOCK_ID, 0, 0, 0, 1, 1, 1);
Block.setDestroyTime(CARDBLOCK_ID, 12);
Block.setExplosionResistance(CARDBLOCK_ID, 32);

Block.defineBlock(BBLOCK_ID, "Barrier Block Activator",[["kpblock",1],["buttonblock",0],["buttonblock",0],["buttonblock",0],["buttonblock",0],["buttonblock",0], ["kpblock",1],["buttonblock",1],["buttonblock",1],["buttonblock",1],["buttonblock",1],["buttonblock",1]], 42);
Block.setShape(BBLOCK_ID, 0, 0, 0, 1, 1, 1);
Block.setDestroyTime(BBLOCK_ID, 12);
Block.setExplosionResistance(BBLOCK_ID, 32);
Block.setRedstoneConsumer(BBLOCK_ID, 1);

Block.defineBlock(BARRIER_ID, "Barrier Block",[["barrierblock",1],["barrierblock",1],["barrierblock",1],["barrierblock",1],["barrierblock",1],["barrierblock",1]], 49);
Block.setShape(BARRIER_ID, 0, 0, 0, 1, 1, 1);
Block.setDestroyTime(BARRIER_ID, 12);
Block.setExplosionResistance(BARRIER_ID, 32);

Block.defineBlock(BARRIER2_ID, "Barrier Block Zero",[["barrierblock",0],["barrierblock",0],["barrierblock",0],["barrierblock",0],["barrierblock",0],["barrierblock",0]], 0, false, 22);
Block.setShape(BARRIER2_ID, 0, 0, 0, 0, 0, 0);
Block.setDestroyTime(BARRIER2_ID, 1);
Block.setExplosionResistance(BARRIER2_ID, 32);
Block.setLightOpacity(BARRIER2_ID, 0);

Block.defineBlock(LBLOCK_ID, "Chest Lock",[["kpblock",1],["buttonblock",2],["buttonblock",2],["buttonblock",2],["buttonblock",2],["buttonblock",2], ["kpblock",1],["buttonblock",3],["buttonblock",3],["buttonblock",3],["buttonblock",3],["buttonblock",3]], 42);
Block.setShape(LBLOCK_ID, 0, 0, 0, 1, 1, 1);
Block.setDestroyTime(LBLOCK_ID, 12);
Block.setExplosionResistance(LBLOCK_ID, 32);
Block.setRedstoneConsumer(LBLOCK_ID, 1);

ModPE.setItem(KEY_ID, "key_card", 0, "Key Card", 1);
ModPE.setItem(RESETTER_ID, "key_card", 1, "Reset Card", 1);

Item.addShapedRecipe(KEY_ID, 1, 0,["iii", "rpp", "ppp"],["i", 265, 0, "r", 331, 0, "p", 339, 0]);
Item.addShapedRecipe(RESETTER_ID, 1, 0,["iii", "rgp", "ppp"],["i", 265, 0, "r", 331, 0, "g", 289, 0, "p", 339, 0]);
Item.addShapedRecipe(PASSBLOCK_ID, 1, 0,["iii", "ipi", "iri"],["i", 265, 0, "r", 331, 0, "p", 339, 0]);
Item.addShapedRecipe(CARDBLOCK_ID, 1, 0,["iii", "ipi", "iei"],["i", 265, 0, "e", 388, 0, "p", 339, 0]);
Item.addShapedRecipe(BBLOCK_ID, 1, 0,["ili", "igi", "iri"],["i", 265, 0, "r", 331, 0, "g", 348, 0, "l", 20, 0]);
Item.addShapedRecipe(LBLOCK_ID, 1, 0,["igi", "grg", "igi"],["i", 265, 0, "r", 331, 0, "g", 266, 0]);
Item.addShapedRecipe(BARRIER_ID, 4, 0,["ooo", "oro", "ooo"],["o", 49, 0, "r", 331, 0]);
Item.addShapedRecipe(330, 3, 0,["ii ", "ii ", "ii "],["i", 265, 0]);

Player.addItemCreativeInv(KEY_ID, 1, 0);
Player.addItemCreativeInv(RESETTER_ID, 1, 0);
Player.addItemCreativeInv(PASSBLOCK_ID, 1, 0);
Player.addItemCreativeInv(CARDBLOCK_ID, 1, 0);
Player.addItemCreativeInv(LBLOCK_ID, 1, 0);
Player.addItemCreativeInv(BBLOCK_ID, 1, 0);
Player.addItemCreativeInv(BARRIER_ID, 1, 0);

function newLevel(){
	clientMessage("Simple Security Mod 2 by "+ChatColor.BLUE+"Dr Lazuli");
}

function useItem(x, y, z, i, b, s){
	if (b==PASSBLOCK_ID && i!=KEY_ID && i!=RESETTER_ID){
		preventDefault();
		guiBlock=[x, y, z];
		if (Level.getData(x, y, z)==0){
			setPass("Passcode");
		}
		else{
			inputPass();
		}
	}

	if (b==CARDBLOCK_ID && i!=KEY_ID && i!=RESETTER_ID){
		preventDefault();
		guiBlock=[x, y, z];
		if (Level.getData(x, y, z)==0){
			setPass("Keycode");
		}
	}

	if (b==BBLOCK_ID && i!=KEY_ID && i!=RESETTER_ID){
		preventDefault();
		var connected=0;
		if ((Level.getTile(x+1, y, z)==PASSBLOCK_ID || Level.getTile(x+1, y, z)==CARDBLOCK_ID) && Level.getData(x+1, y, z)!=0){
			connected=1;
		}
		if ((Level.getTile(x-1, y, z)==PASSBLOCK_ID || Level.getTile(x-1, y, z)==CARDBLOCK_ID) && Level.getData(x-1, y, z)!=0){
			connected=1;
		}
		if ((Level.getTile(x, y, z+1)==PASSBLOCK_ID || Level.getTile(x, y, z+1)==CARDBLOCK_ID) && Level.getData(x, y, z+1)!=0){
			connected=1;
		}
		if ((Level.getTile(x, y, z-1)==PASSBLOCK_ID || Level.getTile(x, y, z-1)==CARDBLOCK_ID) && Level.getData(x, y, z-1)!=0){
			connected=1;
		}
		if (!connected){
			activateBar(x, y, z, Level.getData(x, y, z));
			Level.setTile(x, y, z, BBLOCK_ID, !Level.getData(x, y, z))
		}
	}

	if (b==LBLOCK_ID && i!=KEY_ID && i!=RESETTER_ID){
		preventDefault();
		var connected=0;
		if ((Level.getTile(x+1, y, z)==PASSBLOCK_ID || Level.getTile(x+1, y, z)==CARDBLOCK_ID) && Level.getData(x+1, y, z)!=0){
			connected=1;
		}
		if ((Level.getTile(x-1, y, z)==PASSBLOCK_ID || Level.getTile(x-1, y, z)==CARDBLOCK_ID) && Level.getData(x-1, y, z)!=0){
			connected=1;
		}
		if ((Level.getTile(x, y, z+1)==PASSBLOCK_ID || Level.getTile(x, y, z+1)==CARDBLOCK_ID) && Level.getData(x, y, z+1)!=0){
			connected=1;
		}
		if ((Level.getTile(x, y, z-1)==PASSBLOCK_ID || Level.getTile(x, y, z-1)==CARDBLOCK_ID) && Level.getData(x, y, z-1)!=0){
			connected=1;
		}
		if (!connected){
			Level.setTile(x, y, z, LBLOCK_ID, !Level.getData(x, y, z))
		}
	}

	if (b==54){
		var locked=0;
		if (Level.getTile(x+1, y, z)==LBLOCK_ID && Level.getData(x+1, y, z)==0){
			locked=1;
		}
		if (Level.getTile(x-1, y, z)==LBLOCK_ID && Level.getData(x-1, y, z)==0){
			locked=1;
		}
		if (Level.getTile(x, y, z+1)==LBLOCK_ID && Level.getData(x, y, z+1)==0){
			locked=1;
		}
		if (Level.getTile(x, y, z-1)==LBLOCK_ID && Level.getData(x, y, z-1)==0){
			locked=1;
		}
		if (Level.getTile(x, y-1, z)==LBLOCK_ID && Level.getData(x, y-1, z)==0){
			locked=1;
		}
		if (locked){
			preventDefault();
			ModPE.showTipMessage(ChatColor.YELLOW+"Locked");
		}
	}

	if (i==KEY_ID){
		preventDefault();
		if (b!=CARDBLOCK_ID){
			if (Player.getCarriedItemData()==0){
				setKey();
			}
		}
		else{
			if (Level.getData(x, y, z)==0){
				guiBlock=[x, y, z];
				setPass("Passcode");
			}
			else{
				if (Level.getData(x, y, z)==Player.getCarriedItemData()){
					activatePass(x, y, z);

					ModPE.showTipMessage(ChatColor.GREEN+"Access Granted!");
				}
				else{
					ModPE.showTipMessage(ChatColor.RED+"Wrong Keycode");
				}
			}
		}
	}
	
	if (i==RESETTER_ID){
		preventDefault();
		if (b==PASSBLOCK_ID){
			if (Level.getData(x, y, z)==Player.getCarriedItemData()){
				Level.setTile(x, y, z, PASSBLOCK_ID, 0)
				ModPE.showTipMessage(ChatColor.GREEN+"Passcode Reset");
			}
			else{
				ModPE.showTipMessage(ChatColor.RED+"Wrong Keycode");
			}
		}
		else if (b==CARDBLOCK_ID){
			if (Level.getData(x, y, z)==Player.getCarriedItemData()){
				Level.setTile(x, y, z, CARDBLOCK_ID, 0)
				ModPE.showTipMessage(ChatColor.GREEN+"Keycode Reset");
			}
			else{
				ModPE.showTipMessage(ChatColor.RED+"Wrong Keycode");
			}
		}
		else{
			if (Player.getCarriedItemData()==0){
				setKey();
			}
		}
	}
}

function redstoneUpdateHook(x, y, z, newCurrent, idk, b, d){
	if (b==BBLOCK_ID){
		activateBar(x, y, z, Level.getData(x, y, z));
		Level.setTile(x, y, z, BBLOCK_ID, !Level.getData(x, y, z))
	}
	if (b==LBLOCK_ID){
		Level.setTile(x, y, z, LBLOCK_ID, !Level.getData(x, y, z))
	}
}

function setPass(type)
{
	Activity.runOnUiThread(new java.lang.Runnable()
	{
		run: function()
		{
			try{
			
			var layout = new android.widget.LinearLayout(Activity);
			layout.setOrientation(android.widget.LinearLayout.VERTICAL);
			
			var scroll = new android.widget.ScrollView(Activity);
			scroll.addView(layout);
			
			var popup = new android.app.Dialog(Activity); 
			popup.setContentView(scroll);
			popup.setTitle("Set "+type);
			
			var inputText = new android.widget.EditText(Activity);
			inputText.setHint("Insert a number (1 - 15)");
			layout.addView(inputText);
			
			var enterButton = new android.widget.Button(Activity); 
			enterButton.setText("Enter"); 
			enterButton.setOnClickListener(new android.view.View.OnClickListener()
			{
				onClick: function()
				{
					if (inputText.getText().length!=0 && parseInt(inputText.getText())==inputText.getText() && parseInt(inputText.getText())<=15){
						Level.setTile(guiBlock[0], guiBlock[1], guiBlock[2], Level.getTile(guiBlock[0], guiBlock[1], guiBlock[2]), parseInt(inputText.getText()));
						popup.dismiss();
					}
					else{
						ModPE.showTipMessage(ChatColor.RED+"Not a Valid Passcode");
					}
				}
			}); 
			layout.addView(enterButton);
			
			var backButton = new android.widget.Button(Activity); 
			backButton.setText("Back"); 
			backButton.setOnClickListener(new android.view.View.OnClickListener()
			{
				onClick: function()
				{
					popup.dismiss();
				}
			}); 
			layout.addView(backButton);
			
			popup.show()
			
			}catch (error){
				clientMessage("Error: " + error);
				clientMessage("Oops! Something went wrong!");
			}
		}
	});
}

function inputPass()
{
	Activity.runOnUiThread(new java.lang.Runnable()
	{
		run: function()
		{
			try{
			
			var layout = new android.widget.LinearLayout(Activity);
			layout.setOrientation(android.widget.LinearLayout.VERTICAL);
			
			var scroll = new android.widget.ScrollView(Activity);
			scroll.addView(layout);
			
			var popup = new android.app.Dialog(Activity); 
			popup.setContentView(scroll);
			popup.setTitle("Input Passcode");
			
			var inputText = new android.widget.EditText(Activity);
			inputText.setHint("Please input the passcode");
			layout.addView(inputText);
			
			var enterButton = new android.widget.Button(Activity); 
			enterButton.setText("Enter"); 
			enterButton.setOnClickListener(new android.view.View.OnClickListener()
			{
				onClick: function()
				{
					if (inputText.getText()==Level.getData(guiBlock[0], guiBlock[1], guiBlock[2]).toString()){
						ModPE.showTipMessage(ChatColor.GREEN+"Access Granted!");
						activatePass(guiBlock[0], guiBlock[1], guiBlock[2]);
						popup.dismiss();
					}
					else{
						ModPE.showTipMessage(ChatColor.RED+"Wrong Passcode");
						popup.dismiss();
					}
				}
			}); 
			layout.addView(enterButton);
			
			var backButton = new android.widget.Button(Activity); 
			backButton.setText("Back"); 
			backButton.setOnClickListener(new android.view.View.OnClickListener()
			{
				onClick: function()
				{
					popup.dismiss();
				}
			}); 
			layout.addView(backButton);
			
			popup.show()
			
			}catch (error){
				clientMessage("Error: " + error);
				clientMessage("Oops! Something went wrong!");
			}
		}
	});
}

function setKey()
{
	Activity.runOnUiThread(new java.lang.Runnable()
	{
		run: function()
		{
			try{
			
			var layout = new android.widget.LinearLayout(Activity);
			layout.setOrientation(android.widget.LinearLayout.VERTICAL);
			
			var scroll = new android.widget.ScrollView(Activity);
			scroll.addView(layout);
			
			var popup = new android.app.Dialog(Activity); 
			popup.setContentView(scroll);
			popup.setTitle("Set Keycode");
			
			var inputText = new android.widget.EditText(Activity);
			inputText.setHint("Insert a number (1 - 15)");
			layout.addView(inputText);
			
			var enterButton = new android.widget.Button(Activity); 
			enterButton.setText("Enter"); 
			enterButton.setOnClickListener(new android.view.View.OnClickListener()
			{
				onClick: function()
				{
					if (inputText.getText().length!=0 && parseInt(inputText.getText())==inputText.getText() && parseInt(inputText.getText())<=15){
						if (Player.getCarriedItem()==KEY_ID){
							Entity.setCarriedItem(Player.getEntity(), KEY_ID, 1, parseInt(inputText.getText()))
						}
						if (Player.getCarriedItem()==RESETTER_ID){
							Entity.setCarriedItem(Player.getEntity(), RESETTER_ID, 1, parseInt(inputText.getText()))
						}
						popup.dismiss();
					}
					else{
						ModPE.showTipMessage(ChatColor.RED+"Not a Valid Passcode");
					}
				}
			}); 
			layout.addView(enterButton);
			
			var backButton = new android.widget.Button(Activity); 
			backButton.setText("Back"); 
			backButton.setOnClickListener(new android.view.View.OnClickListener()
			{
				onClick: function()
				{
					popup.dismiss();
				}
			}); 
			layout.addView(backButton);
			
			popup.show()
			
			}catch (error){
				clientMessage("Error: " + error);
				clientMessage("Oops! Something went wrong!");
			}
		}
	});
}

function activatePass(x, y, z){
	if (Level.getTile(x+1, y, z)==71){
		door(x+1, y, z, 1);
	}
	if (Level.getTile(x-1, y, z)==71){
		door(x-1, y, z, 1);
	}
	if (Level.getTile(x, y, z+1)==71){
		door(x, y, z+1, 1);
	}
	if (Level.getTile(x, y, z-1)==71){
		door(x, y, z-1, 1);
	}

	if (Level.getTile(x+1, y, z)==BBLOCK_ID){
		activateBar(x+1, y, z, Level.getData(x+1, y, z));
		Level.setTile(x+1, y, z, BBLOCK_ID, !Level.getData(x+1, y, z))
	}
	if (Level.getTile(x-1, y, z)==BBLOCK_ID){
		activateBar(x-1, y, z, Level.getData(x-1, y, z));
		Level.setTile(x-1, y, z, BBLOCK_ID, !Level.getData(x-1, y, z))
	}
	if (Level.getTile(x, y, z+1)==BBLOCK_ID){
		activateBar(x, y, z+1, Level.getData(x, y, z+1));
		Level.setTile(x, y, z+1, BBLOCK_ID, !Level.getData(x, y, z+1))
	}
	if (Level.getTile(x, y, z-1)==BBLOCK_ID){
		activateBar(x, y, z-1, Level.getData(x, y, z-1));
		Level.setTile(x, y, z-1, BBLOCK_ID, !Level.getData(x, y, z-1))
	}

	if (Level.getTile(x+1, y, z)==LBLOCK_ID){
		Level.setTile(x+1, y, z, LBLOCK_ID, !Level.getData(x+1, y, z))
	}
	if (Level.getTile(x-1, y, z)==LBLOCK_ID){
		Level.setTile(x-1, y, z, LBLOCK_ID, !Level.getData(x-1, y, z))
	}
	if (Level.getTile(x, y, z+1)==LBLOCK_ID){
		Level.setTile(x, y, z+1, LBLOCK_ID, !Level.getData(x, y, z+1))
	}
	if (Level.getTile(x, y, z-1)==LBLOCK_ID){
		Level.setTile(x, y, z-1, LBLOCK_ID, !Level.getData(x, y, z-1))
	}
}

function activateBar(x, y, z, enable){
	for(var h=(x-8); h<=(x+8); h++){
	for(var j=(y-8); j<=(y+8); j++){
	for(var k=(z-8); k<=(z+8); k++){
		if (enable){
			if (Level.getTile(h, j, k)==BARRIER_ID){
				Level.setTile(h, j, k, BARRIER2_ID)
			}
		}
		else{
			if (Level.getTile(h, j, k)==BARRIER2_ID){
				Level.setTile(h, j, k, BARRIER_ID)
			}
		}
	}
	}
	}
}

function door(x, y, z, s){
	var open = Level.getData(x,y,z);
	if (!(open>=8)){
		if (open>=4){
			open=open-4;
		}
		else{
			open=open+4;
		}
		
		setTile(x,y,z,getTile(x,y,z),open);
		if (s){
			Level.playSound(x, y, z, "random.door_open", 1);
		}
	}
	else{
		if (!(Level.getData(x, y-1, z)>=8)){
			door(x, y-1, z, s)
		}
	}
}

function doorOpen(x, y, z, enable, s){
	var open = Level.getData(x,y,z);
	
	if (!(open>=8)){
		if (enable=1){
		if (open<4){
			open=open+4;
		}
		}
		else{
		if (open>=4){
			open=open-4;
		}
		}
		
		setTile(x,y,z,getTile(x,y,z),open);
		if (s){
			Level.playSound(x, y, z, "random.door_open", 1);
		}
	}
	else{
		if (!(Level.getData(x, y-1, z)>=8)){
			doorOpen(x, y-1, z, enable, s)
		}
	}
}